diff --git a/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java b/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java
index ddc897956..41e88577d 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java
@@ -2,8 +2,8 @@ package net.minecraft.client.gui.guidebook.cover;
 
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.Global;
 
 public class CoverPage
@@ -18,13 +18,13 @@ public class CoverPage
     }
 
     @Override
-    public void renderBackground(RenderEngine re, int x, int y) {
+    public void renderBackground(TextureManager re, int x, int y) {
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/cover.png"));
         drawTexturedModalRect(x, y, 0, 0, 158, 220);
     }
 
     @Override
-    public void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    public void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         drawStringCenteredNoShadow(fr, Global.VERSION, x + 84, y + 151, (getSection().getForegroundColor() & 0xFCFCFC) >> 2);
         drawStringCenteredNoShadow(fr, Global.VERSION, x + 84, y + 150, getSection().getForegroundColor());
     }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
index ac8937515..c1d084552 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.gui.guidebook.crafting;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiTooltip;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.TooltipElement;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
@@ -35,8 +35,8 @@ public class CraftingPage
 
     public List<GuidebookSlot> slots;
     public Map<RecipeEntryCrafting<?,?>,List<GuidebookSlot>> map;
-    private final GuiTooltip guiTooltip;
-    private final GuiRenderItem guiRenderItem;
+    private final TooltipElement tooltipElement;
+    private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
     private static Player player;
     private static long ticks = 0;
@@ -48,8 +48,8 @@ public class CraftingPage
         this.map = new HashMap<>();
         player = mc.thePlayer;
         player.addStat(Achievements.OPEN_GUIDEBOOK,1);
-        guiTooltip = new GuiTooltip(mc);
-        guiRenderItem = new GuiRenderItem(mc);
+        tooltipElement = new TooltipElement(mc);
+        itemElement = new ItemElement(mc);
         int recipeAmount = 0;
         int xOffset = 32;
         int yOffset = 12;
@@ -172,7 +172,7 @@ public class CraftingPage
     }
 
     @Override
-    protected void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
             drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
         }
@@ -190,7 +190,7 @@ public class CraftingPage
             }
             drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            guiRenderItem.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            itemElement.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
@@ -212,8 +212,8 @@ public class CraftingPage
                     String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
-                    GuiGuidebook.getPageManager().updatePages();
-                    GuiGuidebook.getPageManager().setCurrentPage(GuiGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    GuidebookScreen.getPageManager().updatePages();
+                    GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
@@ -226,21 +226,21 @@ public class CraftingPage
                     String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
-                    GuiGuidebook.getPageManager().updatePages();
-                    GuiGuidebook.getPageManager().setCurrentPage(GuiGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    GuidebookScreen.getPageManager().updatePages();
+                    GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
                 }
             }
         }
     }
 
     @Override
-    public void render(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    public void render(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.render(re, fr, x, y, mouseX, mouseY, partialTicks);
 
     }
 
     @Override
-    protected void renderBackground(RenderEngine re, int x, int y) {
+    protected void renderBackground(TextureManager re, int x, int y) {
         super.renderBackground(re, x, y);
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
@@ -251,7 +251,7 @@ public class CraftingPage
     }
 
     @Override
-    protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderOverlay(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
         GuidebookSlot mouseOverSlot = null;
         for (GuidebookSlot slot : slots) {
@@ -260,10 +260,10 @@ public class CraftingPage
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
-                    guiTooltip.render(str, mouseX, mouseY, 8, -8);
+                    tooltipElement.render(str, mouseX, mouseY, 8, -8);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/index/IndexPage.java b/src/main/java/net/minecraft/client/gui/guidebook/index/IndexPage.java
index a3ea8981d..bb25150a4 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/index/IndexPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/index/IndexPage.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.gui.guidebook.index;
 
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.PageManager;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.opengl.GL11;
 
@@ -27,7 +27,7 @@ public class IndexPage
     }
 
     @Override
-    protected void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         int yOffset = 10;
         for (int i = startIndex; i < startIndex + LINES_PER_PAGE && i < lines.size() / 2; i++) {
             int j = i - startIndex;
@@ -66,7 +66,7 @@ public class IndexPage
     @Override
     public void onMouseDown(int x, int y, int mouseX, int mouseY, int button) {
         super.onMouseDown(x, y, mouseX, mouseY, button);
-        PageManager pageManager = GuiGuidebook.getPageManager();
+        PageManager pageManager = GuidebookScreen.getPageManager();
 
         int yOffset = 10;
         for (int i = startIndex; i < startIndex + LINES_PER_PAGE && i < lines.size(); i++) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
index fd44d2cd8..fd208ccdb 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
@@ -1,8 +1,9 @@
 package net.minecraft.client.gui.guidebook.mobs;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiTooltip;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.render.*;
@@ -22,11 +23,13 @@ import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
+import org.slf4j.Logger;
 
 import java.util.*;
 
 public class MobPage
     extends GuidebookPage {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final Class<? extends Entity> mobClass;
     private final MobInfoRegistry.MobInfo mobInfo;
     private final Mob example;
@@ -35,8 +38,8 @@ public class MobPage
     private List<GuidebookSlot> slots;
     private Map<MobInfoRegistry.MobDrop, GuidebookSlot> dropSlotMap;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
-    private static final GuiRenderItem guiRenderItem = new GuiRenderItem(mc);
-    private static final GuiTooltip guiTooltip = new GuiTooltip(mc);
+    private static final ItemElement itemElement = new ItemElement(mc);
+    private static final TooltipElement tooltipElement = new TooltipElement(mc);
     private boolean discovered;
 
 
@@ -50,7 +53,7 @@ public class MobPage
         try {
             example = (Mob) mobClass.getConstructor(World.class).newInstance((Object)null);
         } catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.error("Failed to create example instance of mob '{}'!", mobClass.getSimpleName(), e);
         }
         this.example = example;
         if (example != null) example.setSkinVariant(0);
@@ -69,7 +72,7 @@ public class MobPage
         discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.classToKeyMap.get(mobClass))) > 0;
     }
 
-    private static String[] createDescLines(FontRenderer fr, String languageKey) {
+    private static String[] createDescLines(Font fr, String languageKey) {
         String[] words = I18n.getInstance().translateKey(languageKey).split(" ");
         List<String> lines = new ArrayList<>();
         StringBuilder line = new StringBuilder();
@@ -97,14 +100,14 @@ public class MobPage
     }
 
     @Override
-    protected void renderBackground(RenderEngine re, int x, int y) {
+    protected void renderBackground(TextureManager re, int x, int y) {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/mob.png"));
         drawTexturedModalRect(x, y, 0, 0, 158, 220);
     }
 
     @Override
-    protected void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.classToKeyMap.get(mobClass))) > 0;
         if (mc.thePlayer.getGamemode() == Gamemode.creative || !mc.gameSettings.hideUndiscoveredItems.value) discovered = true;
 
@@ -192,7 +195,7 @@ public class MobPage
                         drawSlot(x + 7 + (i % 7) * 21, yOffset + (i / 7) * 20, 0xFFFFFFFF);
                         GL11.glPushMatrix();
                         GL11.glTranslatef(0, 0, 50f);
-                        guiRenderItem.render(slot.getItem(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
+                        itemElement.render(slot.getItem(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
                         GL11.glPopMatrix();
                         if (slot.getIsDiscovered(mc.thePlayer)) {
                             String amountString = drop.getMinAmount() == drop.getMaxAmount() ? String.valueOf(drop.getMinAmount()) : drop.getMinAmount() + "-" + drop.getMaxAmount();
@@ -283,7 +286,7 @@ public class MobPage
     }
 
     @Override
-    protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderOverlay(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
         if (slots == null) return;
         GuidebookSlot mouseOverSlot = null;
@@ -293,10 +296,10 @@ public class MobPage
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
-                    guiTooltip.render(str, mouseX, mouseY, 8, -8);
+                    tooltipElement.render(str, mouseX, mouseY, 8, -8);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
index 3e0b70782..b0d9790b7 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
@@ -1,18 +1,18 @@
 package net.minecraft.client.gui.guidebook.search;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiTextField;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.guidebook.*;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.net.command.TextFormatting;
 
 public class SearchPage extends GuidebookPage {
 
-    public static final GuiTextField searchField = new GuiTextField(null, Minecraft.getMinecraft(SearchPage.class).fontRenderer,0,0,120,20,"","Search...");
-    public final GuiButton searchClearButton = new GuiButton(0,0,0,20,20,"X");
+    public static final TextFieldElement searchField = new TextFieldElement(null, Minecraft.getMinecraft(SearchPage.class).font,0,0,120,20,"","Search...");
+    public final ButtonElement searchClearButton = new ButtonElement(0,0,0,20,20,"X");
     private final Minecraft mc = Minecraft.getMinecraft(SearchPage.class);
 
     public SearchPage(GuidebookSection section) {
@@ -20,7 +20,7 @@ public class SearchPage extends GuidebookPage {
     }
 
     @Override
-    protected void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         searchField.xPosition = x + width/2 - searchField.width/2 - 10;
         searchField.yPosition = y + height/2 - searchField.height/2 - 70;
         searchClearButton.xPosition = searchField.xPosition + searchField.width + 5;
@@ -29,7 +29,7 @@ public class SearchPage extends GuidebookPage {
         searchClearButton.drawButton(mc,mouseX,mouseY);
 
         int results = 0;
-        for (GuidebookPage page : GuiGuidebook.getPageManager().getPages()) {
+        for (GuidebookPage page : GuidebookScreen.getPageManager().getPages()) {
             if (page instanceof RecipePage) {
                 results += ((RecipePage<?>) page).recipes.size();
             }
@@ -71,12 +71,12 @@ public class SearchPage extends GuidebookPage {
         searchField.mouseClicked(mouseX,mouseY,button);
         if(searchField.isFocused){
             PageManager.searchQuery = SearchQuery.resolve(searchField.getText());
-            GuiGuidebook.getPageManager().updatePages();
+            GuidebookScreen.getPageManager().updatePages();
         }
         if(searchClearButton.mouseClicked(mc,mouseX,mouseY)){
             searchField.setText("");
             PageManager.searchQuery = SearchQuery.resolve(searchField.getText());
-            GuiGuidebook.getPageManager().updatePages();
+            GuidebookScreen.getPageManager().updatePages();
         }
     }
 
@@ -85,7 +85,7 @@ public class SearchPage extends GuidebookPage {
         if(searchField.isFocused) {
             searchField.textboxKeyTyped(c, key);
             PageManager.searchQuery = SearchQuery.resolve(searchField.getText());
-            GuiGuidebook.getPageManager().updatePages();
+            GuidebookScreen.getPageManager().updatePages();
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
index 4311a3a2b..25779dde6 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.gui.guidebook.smelting;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiTooltip;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.TooltipElement;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
@@ -32,8 +32,8 @@ public class BlastSmeltingPage
     public static final int RECIPES_PER_PAGE = 6;
     public List<GuidebookSlot> slots;
     public Map<RecipeEntryBlastFurnace,List<GuidebookSlot>> map;
-    private final GuiTooltip guiTooltip;
-    private final GuiRenderItem guiRenderItem;
+    private final TooltipElement tooltipElement;
+    private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
     private static Player player;
     private static long ticks = 0;
@@ -44,8 +44,8 @@ public class BlastSmeltingPage
         this.map = new HashMap<>();
         player = mc.thePlayer;
         player.addStat(Achievements.OPEN_GUIDEBOOK,1);
-        guiTooltip = new GuiTooltip(mc);
-        guiRenderItem = new GuiRenderItem(mc);
+        tooltipElement = new TooltipElement(mc);
+        itemElement = new ItemElement(mc);
 
         for (RecipeEntryBlastFurnace recipe : recipes) {
             List<GuidebookSlot> recipeSlots = new ArrayList<>();
@@ -57,7 +57,7 @@ public class BlastSmeltingPage
     }
 
     @Override
-    protected void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
             drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
         }
@@ -72,7 +72,7 @@ public class BlastSmeltingPage
             }
             drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            guiRenderItem.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            itemElement.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
@@ -94,8 +94,8 @@ public class BlastSmeltingPage
                     String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
-                    GuiGuidebook.getPageManager().updatePages();
-                    GuiGuidebook.getPageManager().setCurrentPage(GuiGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    GuidebookScreen.getPageManager().updatePages();
+                    GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
@@ -108,21 +108,21 @@ public class BlastSmeltingPage
                     String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
-                    GuiGuidebook.getPageManager().updatePages();
-                    GuiGuidebook.getPageManager().setCurrentPage(GuiGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    GuidebookScreen.getPageManager().updatePages();
+                    GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
                 }
             }
         }
     }
 
     @Override
-    public void render(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    public void render(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.render(re, fr, x, y, mouseX, mouseY, partialTicks);
 
     }
 
     @Override
-    protected void renderBackground(RenderEngine re, int x, int y) {
+    protected void renderBackground(TextureManager re, int x, int y) {
         super.renderBackground(re, x, y);
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
@@ -133,7 +133,7 @@ public class BlastSmeltingPage
     }
 
     @Override
-    protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderOverlay(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
         GuidebookSlot mouseOverSlot = null;
         for (GuidebookSlot slot : slots) {
@@ -142,10 +142,10 @@ public class BlastSmeltingPage
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
-                    guiTooltip.render(str, mouseX, mouseY, 8, -8);
+                    tooltipElement.render(str, mouseX, mouseY, 8, -8);
                 }
             }
         }
